#ifndef __PARSER_HH
#define __PARSER_HH
//
// Project : webgen
// File    : parser.hh
// Purpose : functions for parsing the description file
// License : GPL
//
// arch-tag: 410be847-f9a2-427c-828d-f1b286411b63
//

#include "Menu.hh"

///////////////////////////////////////////////////
//
// defines
//
///////////////////////////////////////////////////

//
// different tokens
//

#define TOK_NOTHING  0
#define TOK_EOF      1
#define TOK_SBLOCK   2
#define TOK_EBLOCK   3
#define TOK_ECMD     4

#define TOK_NUM      10
#define TOK_STRING   11
#define TOK_EQUAL    12

#define TOK_MENU     20
#define TOK_TAB      21
#define TOK_NAME     23
#define TOK_CONTENT  24
#define TOK_HTML     25
#define TOK_TITLE    26
#define TOK_HEADLN   27
#define TOK_HEADER   28
#define TOK_FOOTER   29
#define TOK_CSS      30
#define TOK_ADDCSS   31

///////////////////////////////////////////////////
//
// functions
//
///////////////////////////////////////////////////

// open file
int init_parser ( const char * filename );

// return next token in stream
uint get_token ( char * value );

// parse for a specific token
int parse_token ( uint token, char * value );

// read and parse menufile and create menu
void parse ( Menu * menu, std::string & menufile );

#endif
